pipeline {
    agent any
    stages {
        stage('Compile') {
            steps {
                sh 'mvn compile'
            }
        }
        stage('Unit Test') {
            steps {
                sh 'mvn test'
                archiveArtifacts artifacts: 'target/surefire-reports/*.txt', followSymlinks: false
            }
        }
        stage('Package') {
            steps {
                parallel (
                    jar: {
                        sh 'mvn package'
                        sh 'rm target/original-*.jar'
                        archiveArtifacts artifacts: 'target/*.jar', followSymlinks: false
                    },
                    javadoc: {
                        sh 'mvn javadoc:javadoc'
                        archiveArtifacts artifacts: 'target/site/apidocs/*', followSymlinks: false
                    }
                )
            }
        }
        stage('System Test') {
            steps {
                sh 'java -jar target/*.jar -n 20'
            }
        }
    }
}
